# Source for file Interface.php

Documentation is available at Interface.php

1. <?php
2. /**
3. * Copyright (c) 2007-2011, Servigistics, Inc.
4. * All rights reserved.
5. *
6. * Redistribution and use in source and binary forms, with or without
7. * modification, are permitted provided that the following conditions are met:
8. *
9. * - Redistributions of source code must retain the above copyright notice,
10. * this list of conditions and the following disclaimer.
11. * - Redistributions in binary form must reproduce the above copyright
12. * notice, this list of conditions and the following disclaimer in the
13. * documentation and/or other materials provided with the distribution.
14. * - Neither the name of Servigistics, Inc. nor the names of
15. * its contributors may be used to endorse or promote products derived from
16. * this software without specific prior written permission.
17. *
18. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
19. * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
20. * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
21. * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
22. * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
23. * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
24. * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
25. * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
26. * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
27. * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
28. * POSSIBILITY OF SUCH DAMAGE.
29. *
30. * @copyright Copyright 2007-2011 Servigistics, Inc. (http://servigistics.com)
31. * @license http://solr-php-client.googlecode.com/svn/trunk/COPYING New BSD
32. * @version $Id: $
33. *
34. * @package Apache
35. * @subpackage Solr
36. * @author Timo Schmidt <timo.schmidt@aoemedia.de>, Donovan Jimenez <djimenez@conduit-it.com>
37. */
39. // require Apache_Solr_HttpTransport_Response
40. require_once(dirname(__FILE__) . '/Response.php');
42. /**
43. * Interface that all Transport (HTTP Requester) implementations must implement. These
44. * Implementations can then be plugged into the Service instance in order to user their
45. * the desired method for making HTTP requests
46. */
47. interface Apache_Solr_HttpTransport_Interface
48. {
49. /**
50. * Get the current default timeout for all HTTP requests
51. *
52. * @return float
53. */
54. public function getDefaultTimeout();
56. /**
57. * Set the current default timeout for all HTTP requests
58. *
59. * @param float $timeout
60. */
61. public function setDefaultTimeout($timeout);
63. /**
64. * Perform a GET HTTP operation with an optional timeout and return the response
65. * contents, use getLastResponseHeaders to retrieve HTTP headers
66. *
67. * @param string $url
68. * @param float $timeout
69. * @return Apache_Solr_HttpTransport_Response HTTP response
70. */
71. public function performGetRequest($url, $timeout = false);
73. /**
74. * Perform a HEAD HTTP operation with an optional timeout and return the response
75. * headers - NOTE: head requests have no response body
76. *
77. * @param string $url
78. * @param float $timeout
79. * @return Apache_Solr_HttpTransport_Response HTTP response
80. */
81. public function performHeadRequest($url, $timeout = false);
83. /**
84. * Perform a POST HTTP operation with an optional timeout and return the response
85. * contents, use getLastResponseHeaders to retrieve HTTP headers
86. *
87. * @param string $url
88. * @param string $rawPost
89. * @param string $contentType
90. * @param float $timeout
91. * @return Apache_Solr_HttpTransport_Response HTTP response
92. */
93. public function performPostRequest($url, $rawPost, $contentType, $timeout = false);
94. }

Documentation generated on Wed, 04 May 2011 11:01:15 -0400 by phpDocumentor 1.4.3